#!/bin/bash -e


CLASSPATH="../java:../java/sqlitejdbc-v056.jar"
JAVAEXE="java -cp ${CLASSPATH}"

SWISSPROT_SQLITE_DB_URL="http://sourceforge.net/projects/trinityrnaseq/files/misc/TRINOTATE_RESOURCES/TrinityFunctional.swissprot.2012-02-13.db.gz/download"

VERBOSITY="verbose"
#VERBOSITY="counter"



if [ -e TrinityFunctional.db ]; then
    echo reinitializing TrinityFunctional.db
    rm TrinityFunctional.db
fi

if [ ! -e swissprotResource.TrinityFunctional.db ]; then
    echo pulling swissprot resource db from SF ftp site
    wget $SWISSPROT_SQLITE_DB_URL -O swissprotResource.TrinityFunctional.db.gz
    gunzip swissprotResource.TrinityFunctional.db.gz
fi


cp swissprotResource.TrinityFunctional.db TrinityFunctional.db

echo "###############################"
echo Loading protein set
echo "###############################"

#${JAVAEXE} TrinityAminoAcidTosqlLite SpombeSmallSet.fa ${VERBOSITY}
../Trinotate.pl LOAD_transdecoder SpombeSmallSet.fa


echo "##############################"
echo Loading blast results
echo "##############################"

#${JAVAEXE} UniprotBlastoutputtoMySQLLite SpombeTestSet.blastout ${VERBOSITY} uniprot
../Trinotate.pl LOAD_blast SpombeTestSet.blastout


echo "#############################"
echo Loading PFAM results
echo "#############################"

#${JAVAEXE} HmmerDOMoutMYSQLLite SPombetest.hmmer.out ${VERBOSITY} 
../Trinotate.pl LOAD_pfam SPombetest.hmmer.out


echo "############################"
echo Loading TMHMM results
echo "############################"

#${JAVAEXE} tmhmmtoMYSQLlite Spombetest.tmHMM.out ${VERBOSITY}
../Trinotate.pl LOAD_tmhmm Spombetest.tmHMM.out

echo "###########################"
echo Loading SignalP results
echo "###########################"

#${JAVAEXE} SignalPtoMYSQLlite SignalPOut.gff ${VERBOSITY}
../Trinotate.pl LOAD_signalp SignalPOut.gff

echo "###########################"
echo Generating report table
echo "###########################"

#../Trinotate_report_writer.pl > Trinotate_report.xls
../Trinotate.pl report > Trinotate_report.xls


echo "##########################"
echo done.  See annotation summary file:  Trinotate_report.xls
echo "##########################"
